<template>
  <v-container>
    <base-material-input-screen
      style="width: 100%"
      title="Chi tiết sản phẩm"
      text1="Lưu"
      icon1="save"
      icon2="delete"
      icon3="close"
      color3="red"
      @action-1="updateProduct()"
      @action-2="confirmDeleteProd()"
      @back-list="gotoPage('QLSANPHAM')"
    >
      <v-form
        ref="form"
        style="width:100%"
        :class="!isMobile() ? 'pa-5' : ''"
      >
        <v-col
          v-if="!isMobile()"
          cols="12"
          lg="12"
        >
          <!-- FORM THÔNG TIN -->
          <v-row class="cols">
            <v-col
              cols="12"
              lg="5"
              class="pl-0 pt-0 pb-0 pr-5"
            >
              <v-row class="pl-2 pt-0 pb-0 pr-5 cols">
                <span>Hình ảnh</span>
              </v-row>
              <v-row class="pl-2 pt-0 pb-0 pr-5 cols">
                <v-col
                  cols="12"
                  class="text-center pt-0 pb-0 pl-0 main-thumb"
                >
                  <div
                    v-if="!isMobile()"
                    :style="{ 'background-image': `url(${imageData1})` }"
                    class="image-input m-auto rounded-lg"
                    width="500px"
                    @click="chooseImage('THUMB_1')"
                  >
                    <span
                      v-if="!imageData1"
                      class="placeholder"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput1"
                      class="file-input"
                      type="file"
                      @input="onSelectFile1"
                    >
                  </div>
                  <div
                    v-else
                    :style="{ 'background-image': `url(${imageData1})`, 'height':'80px', 'width':'80px' }"
                    class="image-input m-auto rounded-lg"
                    
                    @click="chooseImage('THUMB_1')"
                  >
                    <span
                      v-if="!imageData1"
                      class="placeholder"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput1"
                      class="file-input"
                      type="file"
                      @input="onSelectFile1"
                    >
                  </div>
                </v-col>
                <v-col
                  v-if="!isMobile()"
                  cols="3"
                  class="pb-0 pl-0 pr-0"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData2})` }"
                    class="image-input m-auto rounded-lg thumb"
                    @click="chooseImage('THUMB_2')"
                  >
                    <span
                      v-if="!imageData2"
                      class="placeholder rounded-lg"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput2"
                      class="file-input"
                      type="file"
                      @input="onSelectFile2"
                    >
                  </div>
                </v-col>
                <v-col
                  v-if="!isMobile()"
                  cols="3"
                  class="pb-0 pl-0 pr-0"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData3})` }"
                    class="image-input m-auto rounded-lg thumb"
                    @click="chooseImage('THUMB_3')"
                  >
                    <span
                      v-if="!imageData3"
                      class="placeholder rounded-lg"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput3"
                      class="file-input"
                      type="file"
                      @input="onSelectFile3"
                    >
                  </div>
                </v-col>
                <v-col
                  cols="3"
                  v-if="!isMobile()"
                  class="pb-0 pl-0 pr-0"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData4})` }"
                    class="image-input m-auto rounded-lg thumb"
                    @click="chooseImage('THUMB_4')"
                  >
                    <span
                      v-if="!imageData4"
                      class="placeholder rounded-lg"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput4"
                      class="file-input"
                      type="file"
                      @input="onSelectFile4"
                    >
                  </div>
                </v-col>
                <v-col
                  cols="3"
                  v-if="!isMobile()"
                  class="pb-0 pl-0 pr-0"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData5})` }"
                    class="image-input m-auto rounded-lg thumb"
                    @click="chooseImage('THUMB_5')"
                  >
                    <span
                      v-if="!imageData5"
                      class="placeholder rounded-lg"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput5"
                      class="file-input"
                      type="file"
                      @input="onSelectFile5"
                    >
                  </div>
                </v-col>
              </v-row>
            </v-col>
            <v-col
              cols="12"
              lg="7"
              class="pl-0 pt-0 pb-0 pr-5"
            >
              <v-row class="cols">
                <v-text-field
                  ref="codeModal"
                  v-model="productModel.code"
                  label="Mã hàng (*)"
                  required
                  readonly
                  disabled
                  :rules="nameRules"
                />
              </v-row>
              <v-row class="cols">
                <v-col
                  md="4"
                  class="pl-0 pt-0 pb-0 col"
                >
                  <v-autocomplete
                    ref="spec"
                    v-model="productModel.specification"
                    :items="specification"
                    item-text="name"
                    item-value="id"
                    return-object
                    label="ĐVT"
                    required
                    :rules="dvtRules"
                  />
                </v-col>
                <v-col
                  md="4"
                  class="pl-0 pt-0 pb-0 col"
                >
                  <v-text-field
                    ref="net"
                    v-model="productModel.net"
                    label="KL Tịnh"
                    :rules="nameRules"
                  />
                </v-col>
                <v-col
                  md="4"
                  class="pl-0 pt-0 pb-0 pr-0 col"
                >
                  <v-text-field
                    ref="qtyinventory"
                    v-model="productModel.quota_whosale"
                    label="Tồn kho tối thiểu"
                    required
                    :rules="nameRules"
                  />
                </v-col>
              </v-row>
              <v-row>
                <v-autocomplete
                  ref="category"
                  v-model="productModel.category_code"
                  :items="category"
                  item-text="name"
                  item-value="id"
                  label="Danh mục"
                  return-object
                  required
                  :rules="nameRules"
                />
              </v-row>
              <!-- Giá cả -->
              <v-row
                class="cols"
              >
                <v-col
                  sm="4"
                  md="4"
                  class="pl-0"
                >
                  <v-text-field
                    v-model="productModel.real_price"
                    label="Giá vốn"
                    class="pr-5 text-right"
                    value="0"
                  />
                </v-col>
                <v-col
                  sm="4"
                  md="4"
                >
                  <v-text-field
                    v-model="productModel.wholesale_price"
                    label="Giá sỉ"
                    class="pr-5"
                    value="0"
                  />
                </v-col>
                <v-col
                  sm="4"
                  md="4"
                  class="pr-0"
                >
                  <v-text-field
                    v-model="productModel.retail_price"
                    label="Giá lẻ"
                    value="0"
                  />
                </v-col>
              </v-row>
              <v-row>
                <v-autocomplete
                  ref="suppiler"
                  v-model="productModel.suppiler_code"
                  :items="suppiler_code"
                  return-object
                  item-text="name"
                  item-value="id"
                  label="Nhà cung cấp"
                  required
                  :rules="nameRules"
                />
              </v-row>
            </v-col>
          </v-row>
      
          <v-row class="mt-5">
            <v-text-field
              ref="nameproduct"
              v-model="productModel.name_product"
              :rules="nameRules"
              label="Tên hàng (*)"
              required
              clearable
              autofocus
            />
          </v-row>
          <v-row>
            <v-textarea
              ref="soTienModal"
              v-model="productModel.note"
              rows="3"
              label="Ghi chú"
              class="font-2em"
              clearable
            />
          </v-row>
        </v-col>
        <!-- End desktop -->

        <!-- <Mobile -->
        <v-row
          v-else
          cols="12"
          class="pa-2 mt-0"
        >
          <!-- FORM THÔNG TIN -->
          <v-col cols="12" class="pa-2 mt-0 pt-0">
            <v-row>
              <v-col
                cols="4"
                md="4"
                class="text-center pa-1 ma-0 main-thumb"
              >
                <div
                  :style="{ 'background-image': `url('${JSON.parse(productModel.img_url).thumbs}')`, 'height':'120px', 'width':'120px', 'margin-top':'10%' }"
                  class="image-input m-auto rounded-lg text-center"
                  
                  @click="chooseImage('THUMB_1')"
                >
                  <span
                    v-if="productModel.img_url == undefined"
                    class="placeholder"
                  >
                    PIC
                  </span>
                  <input
                    ref="fileInput1"
                    class="file-input"
                    type="file"
                    @input="onSelectFile1"
                  >
                </div>
              </v-col>
              <v-col
                cols="8"
                md="8">
                <v-text-field
                  ref="codeModal"
                  v-model="productModel.code"
                  label="Mã hàng (*)"
                  required
                  readonly
                  disabled
                  :rules="nameRules"
                />
                <v-autocomplete
                  ref="category"
                  v-model="productModel.category_code"
                  :items="category"
                  item-text="name"
                  item-value="id"
                  label="Danh mục"
                  hide-details="true"
                  return-object
                  required
                  :rules="nameRules"
                />
              </v-col>
            </v-row>
          </v-col>
          <v-col
            cols="12" class="pa-2">
            <v-row>
              <v-col
                cols="12"
                class="pa-1"
              >
                <v-text-field
                  ref="nameproduct"
                  v-model="productModel.name_product"
                  :rules="nameRules"
                  label="Tên hàng (*)"
                  required
                  clearable
                  autofocus
                />
              </v-col>
            </v-row>
          </v-col>
          <v-col
            cols="12"
          >
            <v-row class="cols">
              <v-col
                md="4"
                class="pl-0 pt-0 pb-0 col"
              >
                <v-autocomplete
                  ref="spec"
                  v-model="productModel.specification"
                  :items="specification"
                  item-text="name"
                  item-value="id"
                  return-object
                  label="ĐVT"
                  required
                  :rules="dvtRules"
                />
              </v-col>
              <v-col
                md="4"
                class="pl-0 pt-0 pb-0 col"
              >
                <v-text-field
                  ref="net"
                  v-model="productModel.net"
                  label="KL Tịnh"
                  :rules="nameRules"
                />
              </v-col>
              <v-col
                md="4"
                class="pl-0 pt-0 pb-0 pr-0 col"
              >
                <v-text-field
                  ref="qtyinventory"
                  v-model="productModel.quota_whosale"
                  label="Tồn kho tối thiểu"
                  required
                  :rules="nameRules"
                />
              </v-col>
            </v-row>
            
            <!-- Giá cả -->
            <v-row
              class="cols"
            >
              <v-col
                sm="4"
                md="4"
                class="pl-0"
              >
                <v-text-field
                  v-model="productModel.real_price"
                  label="Giá vốn"
                  class="pr-5 text-right"
                  value="0"
                />
              </v-col>
              <v-col
                sm="4"
                md="4"
              >
                <v-text-field
                  v-model="productModel.wholesale_price"
                  label="Giá sỉ"
                  class="pr-5"
                  value="0"
                />
              </v-col>
              <v-col
                sm="4"
                md="4"
                class="pr-0"
              >
                <v-text-field
                  v-model="productModel.retail_price"
                  label="Giá lẻ"
                  value="0"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-autocomplete
                ref="suppiler"
                v-model="productModel.suppiler_code"
                :items="suppiler_code"
                return-object
                item-text="name"
                item-value="id"
                label="Nhà cung cấp"
                required
                :rules="nameRules"
              />
            </v-row>
            <v-row>
              <v-textarea
                ref="soTienModal"
                v-model="productModel.note"
                rows="3"
                label="Ghi chú"
                class="font-2em"
                clearable
              />
            </v-row>
          </v-col>
          
        </v-row>
        <!-- End mobile -->
        <v-row>
          <dialogConfirm
            ref="dialogConfirm"
            :v-model="dialogConfirm"
            :title="titleConfirm"
            :content="contentConfirm"
            @select-ok="deleteProduct()"
          />
        </v-row>
      </v-form>
    </base-material-input-screen>
  </v-container>
</template>

<script>
  import axios from 'axios'
  import config from '../../config/config.js'
  import totalOrder from '../sales/TotalOrder'
  import dialogConfirm from '../dashboard/component/dialogConfirm'
  export default {
    layout: 'dashboard',
    components: { 
      totalOrder,
      dialogConfirm, },
    data () {
      return {
        valid: false,
        dialog: false,
        panel: [0, 1, 2],
        imageData1: null,
        imageData2: null,
        imageData3: null,
        imageData4: null,
        imageData5: null,
        categoryName: '',
        specificationSearch: '',
        specification: ['GÓI', 'THÙNG', 'KG', 'CÁI', 'HỘP'],
        suppiler_code: [],
        category: ['Bánh Gấu', 'Khô Gà', 'Cơm Cháy'],
        nameRules: [(v) => !!v || 'The field is required'],
        dvtRules: [(v) => !!v || 'The field is required'],
        seqOb: {
          seqCode: 'SP',
          seqName: 'product_code_seq',
          seqDigitNumber: 5,
        },
        productModel: {
          code: '',
          name_product: '',
          category_code: '',
          specification: '',
          suppiler_code: '',
          net: '',
          wholesale_price: '0',
          retail_price: '0',
          quota_whosale: '0',
          quatity_inventory: '0',
          note: '',
          img_url: '',
          real_price: '0',
          create_user: '1',
        },
        dialogConfirm: false,
        titleConfirm: 'Xác nhận',
        contentConfirm: 'Bạn có chắc chắn muốn xóa đơn hàng này không?',
      }
    },
    computed: {},
    mounted: function () {}, // end method
    created () {
      this.setSeqByName()
      this.selectSuppliers()
      this.getSpecs()
      this.getCategories()
      console.log('this.$router.params')
      if (this.$route.params.id !== undefined && this.$route.params.id != null) {
        this.selectProductDetail(this.$route.params.id)
      }
    }, // end data
    methods: {
      isMobile() {
        if(/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
          return true
        } else {
          return false
        }
      },
      gotoPage (page) {
        this.$router.push({ name: page })
      },
      confirmDeleteProd (detail) {
        // this.$refs.dialogConfirm.title = 'Xác nhận'
        // this.$refs.dialogConfirm.text = 'Bạn có chắc chắn muốn xóa đơn hàng này không?'
        
        this.$refs.dialogConfirm.dialog = true
      },
      async updateProduct () {
        console.log('updateProduct')
        this.validate()
        // eslint-disable-next-line no-unused-vars
        const seft = this
        // eslint-disable-next-line no-unused-vars
        console.log(seft.productModel)
        delete seft.productModel.name
        await axios
          .post(config.API_FAMILY + '/api/updateProduct/' + this.$route.params.id, seft.productModel)
          .then(function (response) {
            // productModel = {};
            seft.dialog = false
            console.log(response.data.data)
            seft.$emit('refeshList')
            seft.$router.push({ name: 'QLSANPHAM' })
          })
          .catch(function (error) {
            // handle error
            console.log(error)
          })
          .then(function () {
            console.log('then')

          // always executed
          })
      },
      async deleteProduct () {
        const seft = this
        if (this.productModel !== undefined && this.productModel != null) {
          const jsonReq = JSON.stringify({ product_code: this.productModel.code })
          console.log(jsonReq)
          await axios
            .post(config.API_FAMILY + '/api/delProduct', JSON.parse(jsonReq))
            .then(function (response) {
              var data = response.data.data
              if (data !== undefined && data != null) {
                // productCode = data.seq
              }
              seft.$router.push({ name: 'QLSANPHAM' })
              // seft.snackbaralert(seft.colors[3], 'Đã xóa ' + seft.productSelected.name)
            })
        } else {
          this.snackbaralert(this.colors[4], 'Vui lòng chọn sẩn phẩm cần xóa!')
          
        }
      },
      refeshList () {
        this.$emit('refeshList')
      },
      resetValid () {
        console.log('resetValid')
        this.$refs.form.reset()
      // this.$refs.nameproduct.reset();
      },
      validate () {
        debugger
        console.log('vaild')
        this.$refs.form.validate()
        this.$nextTick(function () {
          // Product name
          if (!this.$refs.nameproduct.validate()) {
            this.$refs.nameproduct.focus()
          } else if (!this.$refs.spec.validate()) {
            this.$refs.spec.focus()
          } else if (!this.$refs.net.validate()) {
            this.$refs.net.focus()
          } else if (!this.$refs.category.validate()) {
            this.$refs.category.focus()
          } else if (!this.$refs.suppiler.validate()) {
            this.$refs.suppiler.focus()
          }

        //  this.setFirstFocusInput(".v-dialog--active",'input, textarea, select', '.v-text-field__slot input[required="required"]');
        })
      },
      chooseImage (ref) {
        if (ref === 'THUMB_1') {
          this.$refs.fileInput1.click()
        }
        if (ref === 'THUMB_2') {
          this.$refs.fileInput2.click()
        }
        if (ref === 'THUMB_3') {
          this.$refs.fileInput3.click()
        }
        if (ref === 'THUMB_4') {
          this.$refs.fileInput4.click()
        }
        if (ref === 'THUMB_5') {
          this.$refs.fileInput5.click()
        }
      },
      onSelectFile1 () {
        console.log('onSelectFile1')
        const input = this.$refs.fileInput1
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData1 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },

      onSelectFile2 () {
        console.log('onSelectFile2')
        const input = this.$refs.fileInput2
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData2 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile3 () {
        console.log('onSelectFile3')
        const input = this.$refs.fileInput3
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData3 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile4 () {
        console.log('onSelectFile4')
        const input = this.$refs.fileInput4
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData4 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile5 () {
        console.log('onSelectFile5')
        const input = this.$refs.fileInput5
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData5 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      async setSeqByName () {
        let productCode = 'SP'
        // this.$refs.nameproduct.focus()
        // this.$refs.form.reset()
        console.log('setSeqByName')
        const self = this
        let dataRes = null
        await axios
          .post(config.API_FAMILY + '/api/getSeqbyName', this.seqOb)
          .then(function (response) {
            console.log('response_setSeqByName')
            console.log(response.data.data)
            dataRes = response.data.data
            if (dataRes !== undefined && dataRes != null) {
              productCode = dataRes.seq
              // self.$refs.productModel = productModel
            }
          })
        this.productModel.code = productCode
        console.log('response_setSeqByName:' + productCode)
      },
      async selectSuppliers () {
        const self = this
        // this.$refs.nameproduct.focus()
        // this.$refs.form.reset()
        console.log('selectSuppliers')
        let dataRes = null
        await axios
          .get(config.API_FAMILY + '/api/selectSuppliers')
          .then(function (response) {
            console.log('response_setSeqByName')
            console.log(response.data.data)
            dataRes = response.data.data
            if (dataRes !== undefined && dataRes != null) {
              self.suppiler_code = dataRes
              // self.$refs.productModel = productModel
            }
          })
      },
      async selectProductDetail (id) {
        const self = this
        // this.$refs.nameproduct.focus()
        // this.$refs.form.reset()
        console.log('selectProductbyId')
        let dataRes = null
        await axios
          .get(config.API_FAMILY + '/api/selectProductbyId/' + id)
          .then(function (response) {
            console.log('selectProductbyId')
            console.log(response.data.data)
            dataRes = response.data.data
            if (dataRes !== undefined && dataRes != null) {
              self.productModel = dataRes[0]
              self.productModel.name_product = self.productModel.name
              // self.productModel.suppiler_code = 'ĂN VẶT 2 ANH EM'
              self.categoryName = 'Khô Gà'
              console.log('productModel')
              console.log(self.productModel)
            }
          })
      },
      async getSpecs () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getSpecs')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.specification = response.data.data
          })
      },
      async getCategories () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getCategories')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.category = response.data.data
          })
      },

    }, // end created
  } // End exxport defaul
</script>
<style scroped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
.table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
}
.image-input{
  display: block;
  max-width:100%;
  height:250px;
  cursor: pointer                  ;
  background-size: cover            ;
  background-position: center center;
  border-radius: 4px;
}
.image-input.thumb{
  display: block;
  max-width:70px;
  height:70px;
  cursor: pointer                  ;
  background-size: cover            ;
  background-position: center center;
  border-radius: 4px;
}
.placeholder{
  background: #F0F0F0     ;
  width: 100%             ;
  height: 100%            ;
  display: flex           ;
  justify-content: center ;
  align-items: center     ;
  color: #333             ;
  font-size: 18px         ;
  font-family: Helvetica   ;
}
.placeholder:hover{
  background: #E0E0E0;
}
.file-input{
  display: none;

}

.main-thumb .placeholder{
  border-radius: 8px;
}

</style>
